.d<-function(lor,a1,b1,a2,b2)
{integrate(
  function(u)
  { dbeta(u/(u+(1-u)*exp(-lor)),shape1=a1,shape2=b1)*
      u*(1-u)*exp(-lor)/(u+(1-u)*exp(-lor))^2*
      dbeta(u,shape1=a2,shape2=b2)
  }
  ,lower=0,upper=1)$value  
}
dLor <- Vectorize(.d,vectorize.args=c("lor"))

.p<-function(lor,a1,a2,b1,b2) 
{integrate(
  function(x)
  { dLor(x,a1,b1,a2,b2)
  }
  ,lower=-500,upper=lor)$value  
}
pLor <- Vectorize(.p,vectorize.args=c("lor"))

.q<-function(p,a1,a2,b1,b2)
{ lorhat <- log((a1-1)/(b1-1))-log((a2-1)/(b2-1))
  selor <- sqrt(1/(a1-1)+1/(b1-1)+1/(a2-1) +1/(b2-1))
  uniroot(function(lor) log10(pLor(lor,a1,a2,b1,b2)/p),lower=lorhat-10*selor, 
          upper=lorhat+10*selor,tol=0.00001)$root
}
qLor <- Vectorize(.q,vectorize.args=c("p"))


HDR <-
  function(A,d_,...) {
    dd_<- match.fun(paste("d",d_,sep=""))
    pd_<- match.fun(paste("p",d_,sep=""))
    qd_<- match.fun(paste("q",d_,sep=""))
    dif_ <- function(lta,...) {
      val_ <- log10(dd_(qd_(lta,...),...)/dd_(qd_(A+lta,...),...))
      return(val_) }
    r_ <- as.numeric(uniroot(dif_,c(.00001,1-A-.00001),...)[1])
    HDR <- c(qd_(r_,...),qd_(A+r_,...))
    Tails <- c(r_,1-r_-A)
    Density <- c(dd_(qd_(r_,...),...),dd_(qd_(A+r_,...),...))
    out_ <- rbind(HDR,Tails,Density)
    colnames(out_) <- c("Lower", "Upper")
    rownames(out_) <- c("HDR","Tails","Density")
    return(out_)
  }
